## Name

gfncopy — Manipulate number of file replicas automatically created

## Synopsis

`gfncopy` [-vh] `path`

`gfncopy` [-vh] [ -C | -M ] -s `NCOPY` `path`

`gfncopy` [-vh] [ -C | -M ] -S `REPATTR` `path`

`gfncopy` [-vh] -r `path` [`path`...]

`gfncopy` [-vh] -c `path`

`gfncopy` [-v] -w [-t `TIMEOUT`] `path` [`path`...]

## DESCRIPTION

gfncopy manipulates the number of file replicas automatically created. When no option is specified, it displays the specified number of file replicas. When replication attributes of both NCOPY and REPATTR are set to a file, these attributes are displayed in two lines. With the `-v` option, it also displays path names up to the ancient directory that specifies the number of file repilcas.

## OPTIONS

`-s` `NCOPY`

  specifies the attribute for automatic replication represented by the number of file replicas to a file or directory. `NCOPY` is stored in the extended attribute of gfarm.ncopy.

`-S` `REPATTR`

  specifies the attribute for automatic replication represented by host groups to a file or directory.

  When both `NCOPY` and `REPATTR` are set to a same file, the following number of replicas will be created. If N is the total number of replicas specified by REPATTR, and N is greater than NCOPY, at least N replicas will be created. Otherwise, replicas will be created according to REPATTR, and more replicas will be added until total number of replicas reaches NCOPY. `REPATTR` is stored in the extended attribute of gfarm.replicainfo.

  a `REPATTR` is represented by the following BNF:

  <repattr> ::= <an_attr> | <an_attr> ',' <repattr>
  <an_attr> ::= <host_group> ':' <num_rep>
  <host_group> ::= <string>
  <num_rep> ::= <integer>
  e.g.)
  group0:2
  group0:1,group1:2,group2:3

`-C`

  If the replication attribute exists already on the file, gfncopy with the `-s` or `-S` options fails.

`-M`

  If the replication attribute does not exist on the file, gfncopy with the `-s` or `-S` options fails.

`-r`

  removes the specified replication attributes.

  The `path` can be specified multiple times.

`-c`

  displays the number of file repicas the file really has.

`-w`

  checks whether or not the file replicas have been created according to the replication attributes (NCOPY or REPATTR), otherwise waits for the completion of the replication.

  The `path` can be specified multiple times.

  If the `path` is a directory, files in subdirectories are checked.

`-t` `TIMEOUT`

  specifies the time in seconds for the `-w` option to wait until automatic replication starts. Timeout does not occur while the replication is running. Default is 30 seconds.

`-h`

  processes symbolic link instead of any referenced files.

`-v`

  displays verbose messages.

`-?`

  displays a list of command options.

## SEE ALSO

gfhostgroup(1), gfarm_attr(5)